package extensions

import data.{Cons, LispList, Nil}

/**
  * Extension methods for LispList.
  */
package object lisplist {

  implicit class LispListOps[A](val lispList: LispList[A]) extends AnyVal {
    import conversions.lisplist._
    def asList: List[A] = lispListToList(lispList)

    def length: Int =
      lispList match {
        case Cons(_, cdr) => 1 + LispListOps(cdr).length
        case Nil          => 0
      }
  }
}
